//+------------------------------------------------------------------+
//|                                                      HiLoBar.mq4 |
//|                                      Copyright  2009, primajaya |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, primajaya"
#property link      ""

//---- input parameters
extern int        TP = 20;
input  int        SL=30;
input  int        BreakEven=10;
extern int        PipsAdd = 5;
extern double     Lot = 0.1;
input  int        MaxOrders=1;
input  int        Trailstart=40;
input  int        Xpips=10;
input  int        Xseconds=10;

#define Magic 7777777
#define Slippage 3

bool sel,mod,cl;
int tic,z;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){
   int total_b=0;
   int total_s=0;
   double uplevel=High[1] + PipsAdd*Point;
   double dnlevel= Low[1] - PipsAdd*Point;
   double highprice=9999999999;
   double lowprice=0;
   datetime lastopen_b=0;
   datetime lastopen_s=0;
   bool no_near_b=true;
   bool no_near_s=true;
   for(z=OrdersTotal()-1;z>=0;z--){
      sel=OrderSelect(z,SELECT_BY_POS);
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic){
//       
         if(OrderType()==OP_BUY){ 
            total_b++;
            if(OrderOpenTime()>lastopen_b) {
               lastopen_b=OrderOpenTime();
               highprice=OrderOpenPrice();
            }
            if(MathAbs(OrderOpenPrice()-Ask)<=PipsAdd*Point)
               no_near_b=false;
            if(Bid>=OrderOpenPrice()+BreakEven*Point&&
            OrderStopLoss()<OrderOpenPrice()){
                mod=OrderModify(OrderTicket(),OrderOpenPrice(),
                OrderOpenPrice(),OrderTakeProfit(),0);
                Alert("BreakEven");              
             }     
             if(Trailstart>0)Trailing();  
         }
         if(OrderType()==OP_SELL){ 
            total_s++; 
            if(OrderOpenTime()>lastopen_s){
               lastopen_s=OrderOpenTime();
               lowprice=OrderOpenPrice();
            }
            if(MathAbs(OrderOpenPrice()-Bid)<=PipsAdd*Point)
               no_near_s=false;
            if(Ask<=OrderOpenPrice()-BreakEven*Point&&
            (OrderStopLoss()>OrderOpenPrice()||OrderStopLoss()==0)){
               mod=OrderModify(OrderTicket(),OrderOpenPrice(),
               OrderOpenPrice(),OrderTakeProfit(),0);
               Alert("BreakEven");
            } 
            if(Trailstart>0)Trailing();  
         } 
      }
   }
   /*double lastclopen_b=0;   
   double lastclopen_s=0;
   datetime lasttime_b=0;
   datetime lasttime_s=0;
   for(z=OrdersHistoryTotal()-1;z>=0;z--)
      {sel=OrderSelect(z,SELECT_BY_POS,MODE_HISTORY);
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic)
         {if(OrderClosePrice()==OrderStopLoss()&&OrderCloseTime()>lasttime_b&&OrderType()==OP_BUY)
            {lasttime_b=OrderCloseTime();
             lastclopen_b=OrderCloseTime();  
            }
          if(OrderClosePrice()==OrderStopLoss()&&OrderCloseTime()>lasttime_s&&OrderType()==OP_SELL)
            {lasttime_s=OrderCloseTime();
            lastclopen_s=OrderCloseTime();
            }  
         }
      }    
//---- 
   bool b=true;
   bool s=true;/2/2
   if(TimeCurrent()-lasttime_s<=Xseconds&&
      Bid-lastclopen_s<Xpips*Point)
      s=false;*/ 
   if(total_b<MaxOrders){
      if(Ask>=uplevel&&Ask<highprice&&no_near_b){
         OpenBuy();
      }
      else{
         if(Ask>highprice+PipsAdd*Point&&no_near_b)
            OpenBuy();
      }  
   }
   if(total_s<MaxOrders){  
      if(Bid<=dnlevel&&Bid>lowprice+PipsAdd*Point&&no_near_s){
         OpenSell();           
      }
      else{
         if(Bid<lowprice-PipsAdd*Point&&no_near_s)
            OpenSell();
      } 
   }  /*
   "\ntotal_b<MaxOrders = ",c(total_b<MaxOrders),
   "\nAsk>=uplevel = ",c(Ask>=uplevel),
   "\n   uplevel = ",uplevel,
   "\n   Ask     = ",Ask,
   "\nAsk<highprice = ",c(Ask<highprice),
   "\nno_near_b = ",c(no_near_b)  */
   return(0);
}  
//+------------------------------------------------------------------+
 
void Trailing()
{double ask=Ask;
double bid=Bid;

if(OrderType()==OP_BUY)
   {double newsl_b=bid-Trailstart*Point;
   if(NormalizeDouble(OrderStopLoss(),Digits)>=NormalizeDouble(OrderOpenPrice(),Digits)&&NormalizeDouble(newsl_b,Digits)>=NormalizeDouble(OrderStopLoss()+Point,Digits)&&OrderStopLoss()!=0)
      {mod=OrderModify(OrderTicket(),OrderOpenPrice(),newsl_b,OrderTakeProfit(),0);
      }
   }
if(OrderType()==OP_SELL)
   {double newsl_s=ask+Trailstart*Point;
   if(NormalizeDouble(OrderStopLoss(),Digits)<=NormalizeDouble(OrderOpenPrice(),Digits)&&NormalizeDouble(newsl_s,Digits)<=NormalizeDouble(OrderStopLoss()-Point,Digits)&&OrderStopLoss()!=0)
      {mod=OrderModify(OrderTicket(),OrderOpenPrice(),newsl_s,OrderTakeProfit(),0);
      }
   }
}   

void OpenBuy()
{tic=OrderSend(Symbol(),OP_BUY,Lot,Ask,Slippage,0,0,"",Magic,0,Navy);
         sel=OrderSelect(tic,SELECT_BY_TICKET);
          if(TP>0&&SL>0)
         mod=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-SL*Point,Digits),NormalizeDouble(OrderOpenPrice()+TP*Point,Digits),0); 
         else
           {
            if(TP>0)
             mod=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(OrderOpenPrice()+TP*Point,Digits),0);   
            if(SL>0)
             mod=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-SL*Point,Digits),OrderTakeProfit(),0);   
           }
}

void OpenSell()
{tic=OrderSend(Symbol(),OP_SELL,Lot,Bid,Slippage,0,0,"",Magic,0,Red);
         sel=OrderSelect(tic,SELECT_BY_TICKET);
         if(TP>0&&SL>0)
         mod=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+SL*Point,Digits),NormalizeDouble(OrderOpenPrice()-TP*Point,Digits),0);   
         else
           {
            if(TP>0)
             mod=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(OrderOpenPrice()-TP*Point,Digits),0);   
            if(SL>0)
             mod=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+SL*Point,Digits),OrderTakeProfit(),0);   
           }  
} 